from sugar.canvas.Menu import Menu
from sugar.canvas.Menu import MenuColorScheme
from sugar.canvas.IconItem import IconItem
from sugar.presence import PresenceService

class BuddyMenu(Menu):
	ACTION_MAKE_FRIEND = 0
	ACTION_INVITE = 1
	ACTION_REMOVE_FRIEND = 2

	def __init__(self, shell, buddy):
		color = buddy.get_color()

		color_scheme = MenuColorScheme()
		color_scheme.text = 'black'
		color_scheme.border = color.get_stroke_color()
		color_scheme.background = color.get_fill_color()
		color_scheme.separator = 'black'

		Menu.__init__(self, shell.get_grid(), buddy.get_name(), color_scheme)

		self._buddy = buddy
		self._shell = shell

		owner = shell.get_model().get_owner()
		if buddy.get_name() != owner.get_name():
			self._add_actions()

	def _add_actions(self):
		shell_model = self._shell.get_model()
		pservice = PresenceService.get_instance()

		friends = shell_model.get_friends()
		if friends.has_buddy(self._buddy):
			icon = IconItem(icon_name='stock-remove-friend')
			self.add_action(icon, BuddyMenu.ACTION_REMOVE_FRIEND) 
		else:
			icon = IconItem(icon_name='stock-make-friend')
			self.add_action(icon, BuddyMenu.ACTION_MAKE_FRIEND)

		icon = IconItem(icon_name='stock-chat')
		self.add_action(icon, -1)

		activity = shell_model.get_current_activity()
		if activity != None:
			activity_ps = pservice.get_activity(activity.get_id())

			# FIXME check that the buddy is not in the activity already

			icon = IconItem(icon_name='stock-invite')
			self.add_action(icon, BuddyMenu.ACTION_INVITE)
